package nl.amis.adfformmanipulation.view;


import java.util.ArrayList;
import java.util.List;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;

import oracle.adf.view.rich.component.rich.RichForm;
import oracle.adf.view.rich.component.rich.input.RichInputText;
import oracle.adf.view.rich.component.rich.layout.RichPanelFormLayout;
import oracle.adf.view.rich.context.AdfFacesContext;

import org.apache.myfaces.trinidad.change.AttributeComponentChange;
import org.apache.myfaces.trinidad.change.AttributeDocumentChange;
import org.apache.myfaces.trinidad.change.ChangeManager;
import org.apache.myfaces.trinidad.change.ComponentChange;
import org.apache.myfaces.trinidad.change.DocumentChange;
import org.apache.myfaces.trinidad.change.ReorderChildrenComponentChange;
import org.apache.myfaces.trinidad.context.RequestContext;
import org.apache.myfaces.trinidad.util.ComponentReference;

public class FormManipulator {

//    UIComponent form;
//
//    public void setForm(UIComponent form) {
//        this.form = form;
//    }
//
//    public UIComponent getForm() {
//        return form;
//    }
    
    private ComponentReference formRef;
     
    public RichPanelFormLayout getForm()
    {
      if (formRef!=null)
      {
        return (RichPanelFormLayout) formRef.getComponent();
      }
      return null; 
    }
     
    public void setForm(RichPanelFormLayout form)
    {
      this.formRef= ComponentReference.newUIComponentReference(form);
    }

    public List<SelectItem> getComponents() {
        List<SelectItem> fields = new ArrayList<SelectItem>();
        for (UIComponent field : getForm().getChildren()) {
            SelectItem si =
                new SelectItem(field, (String)field.getAttributes().get("label"));
            fields.add(si);
        }
        return fields;
    }

    public void setOrder(List<UIComponent> order) {
  System.out.println("should not be inbvoked");
//        List<String> identifiers = new ArrayList<String>();
//        for (UIComponent c : order) {
//            identifiers.add(c.getId());
//        }
//        ReorderChildrenComponentChange roccc =
//            new ReorderChildrenComponentChange(identifiers);
//        roccc.changeComponent(form);
//        // persist the change
//        ChangeManager cm =
//            AdfFacesContext.getCurrentInstance().getPersistentChangeManager();
//        cm.addComponentChange(FacesContext.getCurrentInstance(), form, roccc);
//        AdfFacesContext.getCurrentInstance().addPartialTarget(form);
    }


    public List<UIComponent> getDisplayed() {
        List o = new ArrayList();
        for (UIComponent field : getForm().getChildren()) {
            if ((Boolean)field.getAttributes().get("visible")) {
              o.add(field);
            }
        }
        return o;
    }
    
    public void setDisplayed(List<UIComponent> visible) {
        for (UIComponent c : visible) {
            _addAttributeChange(c, "visible",Boolean.TRUE);        
        }
        // for every element in getComponents that is not in visible we have to set visible to false (or rendered to false)
        List<UIComponent> out = new ArrayList<UIComponent>();
        out.addAll(getForm().getChildren());
        out.removeAll(visible);
        for (UIComponent c : out) {
            _addAttributeChange(c, "visible",Boolean.FALSE);
        }
        // refresh the form to have all show&hide take effect
        AdfFacesContext.getCurrentInstance().addPartialTarget(getForm());
    }

    private void _addAttributeChange(UIComponent uic, String attribName,
                                            Object attribValue) {
        FacesContext fc = FacesContext.getCurrentInstance();
        ChangeManager cm =
            RequestContext.getCurrentInstance().getChangeManager();
        ComponentChange cc =
            new AttributeComponentChange(attribName, attribValue);
        // add the change to the change manager; this persists the change to MDS  
        cm.addComponentChange(fc, uic, cc);
        // now also apply the change to the actual UI component itself
        cc.changeComponent(uic);
    }


}
